using Bp.Sync.BackEnd.Infrastructure.ElasticDbContext;
using Bp.Sync.Domain.Elastics.FcBusinesses.Bills;
using Bp.Sync.Dto.Results;
using Bp.Sync.Dto.SmartTable;
using Microsoft.Extensions.Options;
using Nest;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Infrastructure.Repositories.FcBusinesses
{
    public interface IFcReceiptBillRepository
    {
        Task<BaseResult> Add(FcReceiptBillElastic FcReceiptBill);
        Task<BaseResult> AddManyAsync(IEnumerable<FcReceiptBillElastic> FcReceiptBills);
        Task<BulkResponse> DeleteFcReceiptBills(IEnumerable<FcReceiptBillElastic> FcReceiptBills);
        Task<DeleteByQueryResponse> DeleteFcReceiptBillsByQuery(IEnumerable<long> ids);
        Task<SmartTableResult<FcReceiptBillElastic>> SearchForExcel(BoolQueryDescriptor<FcReceiptBillElastic> query);
        Task<SmartTableResult<FcReceiptBillElastic>> GetByIds(List<long> ids);

    }
    public class FcReceiptBillRepository : IFcReceiptBillRepository
    {
        private readonly ElasticIndex<FcReceiptBillElastic> _dbContext;

        public FcReceiptBillRepository(IOptions<ElasticConnectionSettings> settings)
        {
            _dbContext = new ElasticIndex<FcReceiptBillElastic>(settings.Value.ClusterUrl, "fcreceiptbill");
        }

        #region  search

        public async Task<SmartTableResult<FcReceiptBillElastic>> SearchForExcel(BoolQueryDescriptor<FcReceiptBillElastic> query)
        {
            return await _dbContext.Search(query);
        }

        #endregion

        #region Add order

        public async Task<BaseResult> Add(FcReceiptBillElastic FcReceiptBill)
        {
            var result = new BaseResult() { Result = Dto.Results.Result.Success };
            var rs = await _dbContext.Insert(FcReceiptBill);
            if (rs.IsValid)
            {
                result.Result = Dto.Results.Result.Success;
            }
            else
            {
                result.Result = Dto.Results.Result.SystemError;
                result.Message = "Không tạo được bản ghi";
            }
            return result;
        }
        public async Task<BaseResult> AddManyAsync(IEnumerable<FcReceiptBillElastic> FcReceiptBills)
        {
            var result = new BaseResult { Result = Dto.Results.Result.Success };
            try
            {
                var rs = await _dbContext.InsertMany(FcReceiptBills);
                if (rs.IsValid) return result;
                else
                {
                    result.Result = Dto.Results.Result.Failed;
                    result.Message = rs.Errors.ToString();
                    return result;
                }
            }
            catch (Exception exx)
            {
                result.Result = Dto.Results.Result.Failed;
                result.Message = exx.Message.ToString();
                return result;
            }
        }

        public async Task<BulkResponse> DeleteFcReceiptBills(IEnumerable<FcReceiptBillElastic> FcReceiptBills)
        {
            return await _dbContext.DeleteMany(FcReceiptBills);
        }

        public async Task<DeleteByQueryResponse> DeleteFcReceiptBillsByQuery(IEnumerable<long> ids)
        {
            return await _dbContext.DeleteByIds(ids);
        }

        public async Task<SmartTableResult<FcReceiptBillElastic>> GetByIds(List<long> ids)
        {
            var query = new BoolQueryDescriptor<FcReceiptBillElastic>();
            var idsQ = new QueryContainerDescriptor<FcReceiptBillElastic>();
            idsQ.Terms(t => t.Field(f => f.Id).Terms(ids));
            query.Filter(fl => idsQ);
            return await _dbContext.Search(query);
        }

        #endregion
    }
}
